import psycopg2
from cherrypy.lib import auth_digest
import cherrypy
import numpy as np
import pandas as pd
import os
from os import walk
import daemon
import tarfile
import zipfile
import shutil
import gc

from datetime import datetime

def put_sql(sql_string):
    try:
        conn = psycopg2.connect("dbname=npropes user=npropes password=protocolz123")
        cur = conn.cursor()
        cur.execute(sql_string)
        conn.commit()
        cur.close()
        conn.close()
        print 'put_sql succeeded'
        return True
    except:
        print 'put_sql failed'
        return False

def get_sql(sql_string):
    try:
        conn = psycopg2.connect("dbname=npropes user=npropes password=protocolz123")
        cur = conn.cursor()
        cur.execute(sql_string)
        result = cur.fetchall()
        cur.close()
        conn.close()
        print 'get_sql succeeded'
        return result
    except:
        print 'get_sql failed'
        return None

def delete_table_data(table):
    return put_sql("DELETE FROM " + table + ";")

def get_table_data(table):
    return get_sql("SELECT * FROM " + table + ";")

def add_new_team_login(team_name, team_password):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        result_sql = put_sql("INSERT INTO login (team_name,team_password) VALUES ('%s','%s');" % (team_name,team_password,))
        if result_sql:
            print 'Added new team = ' + team_name + '.'
        else:
            print 'Failed to add new team = ' + team_name + '.'
        return result_sql
    else:
        print 'Team = ' + team_name + ' login already exists'
        return False
        
def add_new_team_contact(team_name, contact_name, contact_email, contact_affiliation):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        print 'Team = ' + team_name + ' does not exist.'
        return False
    else:
        result = get_sql("SELECT * FROM contacts WHERE team_name='" + team_name + "' AND contact_name='"+contact_name+"';")
        if result!=[]:
            print 'Name = ' + contact_name + ' already exists.'
            return False
        else:
            result_sql = put_sql("INSERT INTO contacts (team_name,contact_name,contact_email,contact_affiliation) VALUES ('%s','%s','%s','%s');" % (team_name,contact_name,contact_email,contact_affiliation,))
            if result_sql:
                print 'Added new team contact = ' + contact_name + '.'
            else:
                print 'Failed to add new team contact = ' + contact_name + '.'
            return result_sql

def add_new_team_score(team_name, score, score2, avg, interval_seconds):
    result = get_sql("SELECT * FROM login WHERE team_name='"+team_name+"';")
    if result == []:
        print 'Team = ' + team_name + ' does not exist.'
        return False
    else:
        dt = datetime.now()
        result_sql = get_sql("SELECT time_stamp FROM scores WHERE team_name='" + team_name + "' ORDER BY time_stamp DESC LIMIT 1;")
        if result_sql != []:
            diff = (dt-result_sql[0][0]).total_seconds()
            if diff < interval_seconds:
                print 'Not enough time has elapsed since last submission.'
                return diff
        result_sql = put_sql("INSERT INTO scores (team_name,time_stamp,score,score2,avg) VALUES ('%s','%s',%s,%s,%s);" % (team_name,dt,score,score2,avg))
        if result_sql:
            print 'Added new team score = ' + str(score) + '.'
            print 'Added new team score2 = ' + str(score2) + '.'
            print 'Added new team avg = ' + str(avg) + '.'
        else:
            print 'Failed to add new team = ' + team_name + '.'
        return result_sql

def get_user_password_dict():
    result_sql = get_sql("SELECT team_name,team_password FROM login;")
    if result_sql==None:
        return None
    else:
        return dict(result_sql)

class RootServer:
    @cherrypy.expose
    def index(self):
        scores = get_table_data("scores")
        print scores
        sdf = pd.DataFrame(scores)
        if len(sdf) <= 0:
            sdf = pd.DataFrame(columns = ['team_name','time_stamp','score','score2','avg'])
            return """
<html>
<head>
</head>
<body>
  <h2>2018 PHM SOCIETY DATA CHALLENGE VALIDATION SCORING WEBSITE</h2>
  <b>NOTE</b>: You may have to clear your browser's cache if you have login issues.
  <br><br>
  <h3><b>NOTE 2</b>:  A secondary score is used in the validation portion of the contest. The secondary score is similar in nature to the original score however, the penality is more
  severe for false positives and false negatives.  The final score will be the average of the two scores.  The secondary score is defined as:</h3>
  <br>
    <table style="width:100%" border="1">
      <tr>
        <th>Ground Truth TTF (GT)</th>
        <th>Submission TTF (SUB)</th> 
        <th>Original Score</th>
        <th>Secondary Score</th>
      </tr>
      <tr>
        <td>Number</td>
        <td>Number</td> 
        <td>exp(-0.001*GT)*abs(GT-SUB)</td>
        <td>0.1*(GT-SUB)*(GT-SUB)</td>
      </tr>
      <tr>
        <td>NaN</td>
        <td>Number</td> 
        <td>exp(-0.001*SUB)*abs(SUB)</td>
        <td>5.0/(abs(SUB)+3)</td>
      </tr>
      <tr>
        <td>Number</td>
        <td>NaN</td> 
        <td>exp(-0.001*GT)*abs(GT)</td>
        <td>20*exp(-1.0/(abs(GT)+0.1))</td>
      </tr>
      <tr>
        <td>NaN</td>
        <td>NaN</td> 
        <td>0</td>
        <td>0</td>
      </tr>
    </table>
  <br><br>
  <form action="/secure">
      <input type="submit" value="Click to Login"/>
  </form>
  <h2>No Scores</h2>
</body>
</html>
"""
        sdf.columns = ['team_name','time_stamp','score','score2','avg']
        sdf_group = sdf.groupby('team_name')
        sdf_sort = sdf_group.apply(lambda x: x.sort_values(by=['time_stamp'],ascending=False).iloc[0,:]).reset_index(drop=True)
        sdf_score = sdf_sort[['team_name','score','score2','avg']].sort_values(by=['avg'],ascending=True).reset_index(drop=True)
        sdf_score.index = range(1,len(sdf_score)+1)
        sdf_score.index.name = 'rank'
        sdf_score = sdf_score.reset_index(drop=False)   
        sdf_score_html = sdf_score.to_html(col_space=150,justify='left',index=False)
        return """
<html>
<head>
</head>
<body>
  <h2>2018 PHM SOCIETY DATA CHALLENGE VALIDATION SCORING WEBSITE</h2>
  <b>NOTE</b>: You may have to clear your browser's cache if you have login issues.<br><br>
  <br>
<h3><b>IMPORTANT</b>:  A secondary score is used in the validation portion of the contest. The secondary score is similar in nature to the original score however, the penality is more
  severe for false positives and false negatives.  The final score will be the average of the original and secondary scores.  The secondary score is defined as:</h3>
  <br>
    <table style="width:100%" border="1">
      <tr>
        <th>Ground Truth TTF (GT)</th>
        <th>Submission TTF (SUB)</th> 
        <th>Original Score</th>
        <th>Secondary Score</th>
      </tr>
      <tr>
        <td>Number</td>
        <td>Number</td> 
        <td>exp(-0.001*GT)*abs(GT-SUB)</td>
        <td>0.1*(GT-SUB)*(GT-SUB)</td>
      </tr>
      <tr>
        <td>NaN</td>
        <td>Number</td> 
        <td>exp(-0.001*SUB)*abs(SUB)</td>
        <td>5.0/(abs(SUB)+3)</td>
      </tr>
      <tr>
        <td>Number</td>
        <td>NaN</td> 
        <td>exp(-0.001*GT)*abs(GT)</td>
        <td>20*exp(-1.0/(abs(GT)+0.1))</td>
      </tr>
      <tr>
        <td>NaN</td>
        <td>NaN</td> 
        <td>0</td>
        <td>0</td>
      </tr>
    </table>
  <br>
  <h3>You will be able to submit a solution every 12 hours in the validation phase.  At the end of the contest, the top 4 teams will be invited to write a paper for the conference.  Only non-trival solutions will be accepted and declared winners.  There must be a data-driven and/or physics-based modeling methodology behind your solution.  This is a difficult problem and we appreciate your effort.</h3>
  <br><br>
  <form action="/secure">
      <input type="submit" value="Click to Login"/>
  </form>
  <h2>Latest Scores</h2><div style="display: inline-block;background-color: LightCyan;">""" + sdf_score_html + """</div>
</body>
</html>
"""

class SecureServer:
    @cherrypy.expose
    def index(self):
        user_login = cherrypy.request.login
        scores = get_table_data("scores")
        sdf = pd.DataFrame(scores)
        if len(sdf) <= 0:
            sdf = pd.DataFrame(columns = ['team_name','time_stamp','score','score2','avg'])
            return """
<html><head><script src="https://cdn.plot.ly/plotly-1.2.0.min.js"></script></head><body>
<h2>Submit a File</h2>
<form action="upload" method="post" enctype="multipart/form-data">
<input type="file" name="myFile" /><br/><br>
<input type="submit"/>
</form>
  <h2>No Scores</h2></body>
</html>
"""
        sdf.columns = ['team_name','time_stamp','score','score2','avg']
        sdf_group = sdf.groupby('team_name')
        sdf_sort = sdf_group.apply(lambda x: x.sort_values(by=['time_stamp'],ascending=False).iloc[0,:]).reset_index(drop=True)
        sdf_score = sdf_sort[['team_name','score','score2','avg']].sort_values(by=['avg'],ascending=True).reset_index(drop=True)
        sdf_score.index = range(1,len(sdf_score)+1)
        sdf_score.index.name = 'rank'
        sdf_score = sdf_score.reset_index(drop=False)   
        sdf_score_html = sdf_score.to_html(col_space=150,justify='left',index=False)

        # display score
        scores = get_table_data("scores")
        sdf = pd.DataFrame(scores)
        sdf.columns = ['team_name','time_stamp','score','score2','avg']
        sdf = sdf[sdf['team_name']==user_login].sort_values(by=['time_stamp'],ascending=True).reset_index(drop=True)
        Y1 = list(sdf['avg'].values)
        X = [i for i in range(0,len(Y1))]
        out = """<br><br><h2>TEAM: """ + user_login + """</h2><h2>Score</h2><div id="tester1" style="width:800px;height:300px;"></div>
		<script>
		TESTER1 = document.getElementById('tester1');
		Plotly.plot(TESTER1, [{
		x:""" + str(X) + """, y: """ + str(Y1) + """}], {
		margin: {t:0}});</script>
                """
        return """
<html><head><script src="https://cdn.plot.ly/plotly-1.2.0.min.js"></script></head><body>
<h2>Submit a File</h2>
<form action="upload" method="post" enctype="multipart/form-data">
<input type="file" name="myFile" /><br/><br>
<input type="submit"/>
</form>
  <h2>Latest Scores</h2><div style="display: inline-block;background-color: LightCyan;">""" + sdf_score_html + """</div>""" + out + """
</body>
</html>
"""


    @cherrypy.expose
    def upload(self, myFile):

        gc.disable()
        # submission interval time (seconds)
        time_interval = 60*60*12

        # ground truth file path
        gt_path = '/home/npropes/phm/ground_truth/test'

	# create directory for temporary submitted data file if not existing
        user_login = cherrypy.request.login
        dir_path = '/home/npropes/phm/submissions/' + user_login
        file_name = myFile.filename
        file_path = dir_path + '/' + file_name
        if not os.path.isdir(dir_path):
            os.makedirs(dir_path)

        if not(file_name.endswith("zip")):
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>File must be a zip file (.zip).</h2>
	            <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                   """

##        # delete all files in submission folder
##        dir_path2 = dir_path + '/test'
##        print 'deleting files:'
##        print os.listdir(dir_path2)
##        if not os.path.isdir(dir_path2):
##            os.makedirs(dir_path2)
##        for the_file in os.listdir(dir_path2):
##            file_path = os.path.join(dir_path2, the_file)
##            try:
##                if os.path.isfile(file_path):
##                     os.unlink(file_path)
##                elif os.path.isdir(file_path): shutil.rmtree(file_path)
##            except Exception as e:
##                print(e)

        # copy submitted data to temporary file
        try:
            file_data = myFile.file.read()
        except:
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>Please select a file.</h2>
	            <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                   """
        
        f = open(file_path,'w')
        f.write(file_data)
        f.close()
        del myFile
        del file_data
        del f
        gc.collect()

        try:
            if (file_path.endswith("tar.gz")):
                tar=tarfile.open(file_path,'r:gz')
                tar.extractall(dir_path)
                tar.close()
                del tar
            elif (file_path.endswith("tar")):
                tar=tarfile.open(file_path,'r:')
                tar.extractall(dir_path)
                tar.close()
                del tar
            elif (file_path.endswith("zip")):
                zip_ref = zipfile.ZipFile(file_path,'r')
                zip_ref.extractall(dir_path)
                zip_ref.close()
                del zip_ref
        except:
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>Error in unzipping file.</h2>
	            <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                   """

        try:
            os.remove(file_path)
        except OSError:
            pass

        # submission files path
        submission_path = dir_path + '/' + 'test'

        # get ground truth filenames
        gtf = []
        for (dirpath, dirnames, filenames) in walk(gt_path):
            gtf.extend(filenames)
        print gtf

        # get submitted filenames
        sf = []
        for (dirpath, dirnames, filenames) in walk(submission_path):
            sf.extend(filenames)
        print sf

        # check if number of files is
        if len(sf) < 5:
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>Not enough files submitted.</h2>
	            <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                   """

        if len(sf) > 5:
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>Too many files submitted.</h2>
	            <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                   """

        # compute score
        score = 0
        score2 = 0
        for fn in gtf:
            gt_filepath = gt_path + '/' + fn
            gt_data = pd.read_csv(gt_filepath)
            print 'loaded gt'
            try:
                sub_filepath = submission_path + '/' + fn
                sub_data = pd.read_csv(sub_filepath)
                print 'loaded sub'
            except:
                return """
                        <html>
                        <head></head>
                        <body>
                        <h2>File missing: """ + fn +""".</h2>
                        <form action="/secure">
                        <input type="submit" value="Back"/>
                        </form>
                        </body>
                        </html>
                       """
            if len(gt_data) != len(sub_data):
                return """
                        <html>
                        <head></head>
                        <body>
                        <h2>File length does not match: """ + fn + """.</h2>
                        <form action="/secure">
                        <input type="submit" value="Back"/>
                        </form>
                        </body>
                        </html>
                       """
            gt_data = gt_data.sort_values(by='time',axis=0).reset_index(drop=True)
            gt_data = gt_data[['TTF_FlowCool Pressure Dropped Below Limit','TTF_Flowcool Pressure Too High Check Flowcool Pump','TTF_Flowcool leak']]
            sub_data = sub_data.sort_values(by='time',axis=0).reset_index(drop=True)
            sub_data = sub_data[['TTF_FlowCool Pressure Dropped Below Limit','TTF_Flowcool Pressure Too High Check Flowcool Pump','TTF_Flowcool leak']]
            gt = gt_data.values
            sub = sub_data.values
            del gt_data
            del sub_data

            gc.collect()
            gtnan = np.isnan(gt)
            subnan = np.isnan(sub)
            
            a = np.abs(gt-sub)*np.exp(-0.0001*gt)
            a[np.isnan(a)] = 0
            a = np.sum(a)

            aa = 0.01*(gt-sub)*(gt-sub)
            aa[np.isnan(aa)] = 0
            aa = np.sum(aa)

            print 'a: ' + str(a)
            print 'aa: ' + str(aa)

            b = np.logical_and(gtnan, np.logical_not(subnan))
            b1 = sub.copy()
            b1[np.logical_not(b)] = 0
            b1 = np.exp(-0.0001*b1)*np.abs(b1)
            bb1 = 0.1/(np.abs(sub.copy()[b])+3)
            b = np.sum(b1)
            bb = np.sum(bb1)
            del b1
            del bb1
            gc.collect()

            print 'b: ' + str(b)
            print 'bb: ' + str(bb)

            c = np.logical_and(np.logical_not(gtnan), subnan)
            c1 = gt.copy()
            c1[np.logical_not(c)] = 0
            c1 = np.exp(-0.0001*c1)*np.abs(c1)
            cc1 = np.exp(-1.0/(np.abs(gt.copy()[c])+0.1))
            c = np.sum(c1)
            cc = np.sum(cc1)
            del c1
            del cc1
            gc.collect()

            print 'c: ' + str(c)
            print 'cc: ' + str(cc)            
            
            score = score + (a + b + c)/float(np.size(gt))
            print score

            score2 = score2 + (10*aa + 5*bb + 20*cc)/float(np.size(gt))
            print score2 

            avg = (score + score2)/2.0
      
            gc.enable()


        # load ground truth data
        #ground_truth = pd.read_csv(gt_file_path)

        # load submitted data
##        try:
##            submitted_data = pd.read_csv(file_path)
##        except:
##            return """
##                    <html>
##                    <head></head>
##                    <body>
##                    <h2>Incorrect File Format</h2>
##	            <form action="/secure">
##	 	    <input type="submit" value="Back"/>
##	            </form>
##                    </body>
##                    </html>
##                   """
##
##        # bad file check
##        bad_file = False
##        bad_file = (ground_truth.shape != submitted_data.shape)
##        if bad_file:
##            return """
##                    <html>
##                    <head></head>
##                    <body>
##                    <h2>Incorrect File Format</h2>
##	            <form action="/secure">
##	 	    <input type="submit" value="Back"/>
##	            </form>
##                    </body>
##                    </html>
##                   """

        # check if not enough time has elapsed since last submission
        result = add_new_team_score(user_login,score,score2,avg,time_interval)

        # is it a float, if so not enough time has elapsed
        if isinstance(result,float):
            out =   """<html>
                    <head></head>
                    <body>
                    <h2>Not enough time has elapsed since last submission. """
            if (time_interval-result > 86400):
                out += """Days remaining: """ + "{:5.1f}".format(float(time_interval-result)/86400.0) + """</h2>"""
            elif (time_interval-result > 3600):
                out += """Hours remaining: """ + "{:5.1f}".format(float(time_interval-result)/3600.0) + """</h2>"""
            elif (time_interval-result > 60):
                out += """Minutes remaining: """ + "{:5.1f}".format(float(time_interval-result)/60.0) + """</h2>"""
            else:
                out += """Seconds remaining: """ + "{:5.1f}".format(float(time_interval-result)) + """</h2>"""
            out += """<br><form action="/secure">
	 	      <input type="submit" value="Back"/>
	              </form></body></html>"""
            return out

        
        # if some error occurred in sql transaction
        if not result:
            return """
                    <html>
                    <head></head>
                    <body>
                    <h2>Error submitting score.</h2>
               	    <form action="/secure">
	 	    <input type="submit" value="Back"/>
	            </form>
                    </body>
                    </html>
                    """

        # display score
        scores = get_table_data("scores")
        sdf = pd.DataFrame(scores)
        sdf.columns = ['team_name','time_stamp','score','score2','avg']
        sdf = sdf[sdf['team_name']==user_login].sort_values(by=['time_stamp'],ascending=True).reset_index(drop=True)
        Y1 = list(sdf['avg'].values)
        X = [i for i in range(0,len(Y1))]
        out = """<html>
                <head><script src="https://cdn.plot.ly/plotly-1.2.0.min.js"></script></head>
                <h2>Score = """ + str(avg) + """</h2>
		<div id="tester1" style="width:800px;height:300px;"></div>
                <body>
		<script>
		TESTER1 = document.getElementById('tester1');
		Plotly.plot(TESTER1, [{
		x:""" + str(X) + """, y: """ + str(Y1) + """}], {
		margin: {t:0}});</script>
		<form action="/secure">
	 	<input type="submit" value="Back"/>
	        </form>
                </body>
                </html>
                """
        return out

 

if __name__ == '__main__':
    #delete_table_data('login')
    #delete_table_data('contacts')
    #delete_table_data('scores')
    
    #add_new_team_login("npropes","pecansam")
    #add_new_team_contact("npropes","Nicholas Propes","npropes@gmail.com","Seagate")
    #add_new_team_score("npropes",0.231,60)

    user_pass_list = get_user_password_dict()

    conf = {
        '/secure': {
            'tools.auth_digest.on': True,
            'tools.auth_digest.realm': '70.32.30.237:8080',
            'tools.auth_digest.get_ha1': auth_digest.get_ha1_dict_plain(user_pass_list),
            'tools.auth_digest.key': 'f333b27146791cfa'
            },
        }

    root = RootServer()
    root.secure = SecureServer()

    cherrypy.config.update({'server.socket_host':'70.32.30.237'})
    cherrypy.config.update({'server.max_request_body_size':504857600})
    cherrypy.config.update({'tools.MemoryCache.delay': 5})
    
    with daemon.DaemonContext():
        cherrypy.quickstart(root,'/',conf)
    
